package slices

func Of[T any](values ...T) []T {
	return values
}

// OfMap returns a slice containing the return values of the unmapper function
// applied to any key-value pair in m
// The order is random
func OfMap[K comparable, V, T any](m map[K]V, unmapper func(K, V) T) []T {
	out := make([]T, 0, len(m))
	for k, v := range m {
		out = append(out, unmapper(k, v))
	}
	return out
}
